#! /usr/bin/perl
#
# strip.pl - script to separate iLBC example source from RFC 3951
# Copyright (C) 2008  Tommi Saviranta  <wnd@iki.fi>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

use strict;
use warnings FATAL => 'all';


my $skip = 0;
my @stack;
my $out;

while (<STDIN>) {
	if (/^Andersen, et al./) {
		shift(@stack);
		shift(@stack);
		shift(@stack);
		$skip = 5;
	} elsif (/^A\.\d+\./) {
		defined($out) && close($out);
		my ($file) = m/\s([a-z_]+\.[ch])/i;
		open($out, ">$file") or die "cannot write $file";
		print "$file\n";
		$skip = 2;
	} elsif (/^Authors' Addresses/) {
		last;
	}
	if ($skip == 0 && defined($out)) {
		s/^...//;
		print $out $_;
	} else {
		$skip--;
	}
}

defined($out) && close($out);
